###############################################################################
######### lightOS Makfile                                            ##########
###############################################################################
include ../../Makefile.config
include ../../Makefile.rules

.PHONY : get

DASH_VERSION= 0.5.5.1

SRC_C= $(patsubst %,src/src/%, alias.c arith_yacc.c arith_yylex.c cd.c error.c eval.c exec.c expand.c histedit.c input.c jobs.c mail.c main.c memalloc.c miscbltin.c mystring.c options.c output.c parser.c redir.c show.c system.c trap.c var.c)
OBJ_C= $(SRC_C:src/src/%.c=$(TMP_DASH)/%.o)
INCLUDE=  -I src/src $(LIBC_INCLUDE) $(LIBUNIX_INCLUDE)
DEFINES= -DSMALL -DHAVE_CONFIG_H -D_LIGHTOS_LIBUNIX -D_PATH_TTY='"/dev/tty"' -D_PATH_DEVNULL='"/dev/null"'
LIB= $(LIBGCC) $(LIBLIGHTOS) $(LIBC) $(LIBUNIX)
LIBS= --start-group $(LIB) --end-group

get:
	@./get.sh $(DASH_VERSION)

dep:
	@cd src/src && gcc -DHAVE_CONFIG_H -I. -I. -I..  -include ../config.h -E -x c -o builtins.def builtins.def.in && sh mkbuiltins builtins.def
	@cd src/src && gcc -include ../config.h -o mknodes mknodes.c && ./mknodes nodetypes nodes.c.pat
	@cd src/src && gcc -include ../config.h -o mksyntax mksyntax.c && ./mksyntax
	@cd src/src && sh mktokens
	@makedepend -f - $(DEFINES) $(INCLUDE_MAKEDEPEND) $(INCLUDE) $(SRC_C) -p$(TMP_DASH)/ > $(DEP)

-include $(DEP)

all: dep $(BUILD)/$(ARCH)/bin/dash

$(BUILD)/$(ARCH)/bin/dash: $(OBJ_C) $(CRT0_C) $(LIB)
	@echo " LD     dash"
	@$(LD) $(LD_FLAGS) -T $(LDSCRIPT_C) -o $(@) $(CRT0_C) $(OBJ_C) $(LIBS)

$(TMP_DASH)/%.o: src/src/%.c
	@echo " C      dash/$(@:$(TMP_DASH)/%.o=src/src/%.c)"
	@$(CC) -DPATH_MAX=1024 $(DEFINES) $(BASH_C_FLAGS) $(INCLUDE) -c $(@:$(TMP_DASH)/%.o=src/src/%.c) -o $(@)

clean:
	@rm -f src $(DEP) $(OBJ_C) $(BUILD)/$(ARCH)/bin/dash
	@rm -rf dash-$(DASH_VERSION)
